## uftrace 0.6.0.20161014

=== Makefile ===
VERSION := 0.6

# Makefiles suck: This macro sets a default value of $(2) for the
# variable named by $(1), unless the variable has been set by
# environment or command line. This is necessary for CC and AR
# because make sets default values, so the simpler ?= approach
# won't work as expected.
define allow-override
  $(if $(or $(findstring environment,$(origin $(1))),\
            $(findstring command line,$(origin $(1)))),,\
    $(eval $(1) = $(2)))
endef

# Allow setting CC and AR and LD, or setting CROSS_COMPILE as a prefix.
$(call allow-override,CC,$(CROSS_COMPILE)gcc)
$(call allow-override,AR,$(CROSS_COMPILE)ar)
$(call allow-override,LD,$(CROSS_COMPILE)ld)

uname_M := $(shell uname -m 2>/dev/null || echo not)

ARCH ?= $(shell echo $(uname_M) | sed -e s/i.86/i386/ -e s/arm.*/arm/ )
ifeq ($(ARCH),x86_64)
  ifneq ($(findstring m32,$(CFLAGS)),)
    override ARCH := i386
  endif
endif

prefix ?= /usr/local
bindir = $(prefix)/bin
libdir = $(prefix)/lib
etcdir = $(prefix)/etc
mandir = $(prefix)/share/man

# XXX: use /etc if it's installed in the system directory (i.e. /usr{,/local})
ifneq ($(findstring /usr/local,$(prefix)),)
  etcdir_in_usr := $(etcdir)
  etcdir = $(subst /usr/local/,/,$(etcdir_in_usr))
endif
ifneq ($(findstring /usr,$(prefix)),)
  etcdir_in_usr := $(etcdir)
  etcdir = $(subst /usr/,/,$(etcdir_in_usr))
endif

srcdir = $(CURDIR)
# set objdir to $(O) by default (if any)
ifeq ($(objdir),)
    ifneq ($(O),)
        objdir = $(O)
    else
        objdir = $(CURDIR)
    endif
endif

ifneq ($(wildcard $(objdir)/.config),)
  include $(objdir)/.config
endif

RM = rm -f
INSTALL = install

export ARCH CC AR LD RM srcdir objdir

COMMON_CFLAGS := -O2 -g -D_GNU_SOURCE $(CFLAGS) $(CPPFLAGS)
COMMON_CFLAGS +=  -iquote $(srcdir) -iquote $(objdir) -iquote $(srcdir)/arch/$(ARCH)
#CFLAGS-DEBUG = -g -D_GNU_SOURCE $(CFLAGS_$@)
COMMON_LDFLAGS := -lelf -lrt -ldl -pthread $(LDFLAGS)

COMMON_CFLAGS += -W -Wall -Wno-unused-parameter -Wno-missing-field-initializers

#
# Note that the plain CFLAGS and LDFLAGS can be changed
# by config/Makefile later but *_*FLAGS can not.
#
UFTRACE_CFLAGS = $(COMMON_CFLAGS) $(CFLAGS_$@) $(CFLAGS_uftrace)
TRACEEVENT_CFLAGS = $(COMMON_CFLAGS) $(CFLAGS_$@) $(CFLAGS_traceevent)
LIB_CFLAGS = $(COMMON_CFLAGS) $(CFLAGS_$@) $(CFLAGS_lib) -fPIC -fvisibility=hidden

UFTRACE_LDFLAGS = $(COMMON_LDFLAGS) $(LDFLAGS_$@) $(LDFLAGS_uftrace)
LIB_LDFLAGS = $(COMMON_LDFLAGS) $(LDFLAGS_$@) $(LDFLAGS_lib)

VERSION_GIT := $(shell git describe --tags 2> /dev/null || echo v$(VERSION))

all:

include $(srcdir)/config/Makefile
include $(srcdir)/config/Makefile.include


LIBMCOUNT_TARGETS := libmcount/libmcount.so libmcount/libmcount-fast.so
LIBMCOUNT_TARGETS += libmcount/libmcount-single.so libmcount/libmcount-fast-single.so

_TARGETS := uftrace libtraceevent/libtraceevent.a
_TARGETS += $(LIBMCOUNT_TARGETS) libmcount/libmcount-nop.so
TARGETS  := $(patsubst %,$(objdir)/%,$(_TARGETS))

UFTRACE_SRCS := $(srcdir)/uftrace.c $(wildcard $(srcdir)/cmd-*.c $(srcdir)/utils/*.c)
UFTRACE_SRCS += $(wildcard $(srcdir)/arch/$(ARCH)/cpuinfo.c)
UFTRACE_SRCS += $(wildcard $(srcdir)/arch/$(ARCH)/regs.c)
UFTRACE_OBJS := $(patsubst $(srcdir)/%.c,$(objdir)/%.o,$(UFTRACE_SRCS))

UFTRACE_HDRS := $(wildcard $(srcdir)/*.h $(srcdir)/utils/*.h)
UFTRACE_HDRS += $(srcdir)/libmcount/mcount.h

LIBMCOUNT_SRCS := $(filter-out %-nop.c,$(wildcard $(srcdir)/libmcount/*.c))
LIBMCOUNT_SRCS += $(srcdir)/utils/symbol.c $(srcdir)/utils/debug.c
LIBMCOUNT_SRCS += $(srcdir)/utils/rbtree.c $(srcdir)/utils/filter.c
LIBMCOUNT_SRCS += $(srcdir)/utils/demangle.c $(srcdir)/utils/utils.c
LIBMCOUNT_SRCS += $(wildcard $(srcdir)/arch/$(ARCH)/mcount-support.c)
LIBMCOUNT_SRCS += $(wildcard $(srcdir)/arch/$(ARCH)/regs.c)
LIBMCOUNT_OBJS := $(patsubst $(srcdir)/%.c,$(objdir)/%.op,$(LIBMCOUNT_SRCS))

LIBMCOUNT_NOP_SRCS := $(srcdir)/libmcount/mcount-nop.c
LIBMCOUNT_NOP_OBJS := $(patsubst $(srcdir)/%.c,$(objdir)/%.op,$(LIBMCOUNT_NOP_SRCS))

LIBMCOUNT_FAST_SRCS := $(srcdir)/utils/symbol.c $(srcdir)/utils/debug.c
LIBMCOUNT_FAST_SRCS += $(srcdir)/utils/demangle.c $(srcdir)/utils/utils.c
LIBMCOUNT_FAST_SRCS += $(srcdir)/utils/rbtree.c
LIBMCOUNT_FAST_SRCS += $(wildcard $(srcdir)/arch/$(ARCH)/mcount-support.c)
LIBMCOUNT_FAST_OBJS := $(objdir)/libmcount/mcount-fast.op
LIBMCOUNT_FAST_OBJS += $(objdir)/libmcount/record-fast.op
LIBMCOUNT_FAST_OBJS += $(objdir)/libmcount/plthook-fast.op
LIBMCOUNT_FAST_OBJS += $(patsubst $(srcdir)/%.c,$(objdir)/%.op,$(LIBMCOUNT_FAST_SRCS))

LIBMCOUNT_SINGLE_SRCS := $(srcdir)/utils/symbol.c $(srcdir)/utils/debug.c
LIBMCOUNT_SINGLE_SRCS += $(srcdir)/utils/rbtree.c $(srcdir)/utils/filter.c
LIBMCOUNT_SINGLE_SRCS += $(srcdir)/utils/demangle.c $(srcdir)/utils/utils.c
LIBMCOUNT_SINGLE_SRCS += $(wildcard $(srcdir)/arch/$(ARCH)/mcount-support.c)
LIBMCOUNT_SINGLE_SRCS += $(wildcard $(srcdir)/arch/$(ARCH)/regs.c)
LIBMCOUNT_SINGLE_OBJS := $(objdir)/libmcount/mcount-single.op
LIBMCOUNT_SINGLE_OBJS += $(objdir)/libmcount/record-single.op
LIBMCOUNT_SINGLE_OBJS += $(objdir)/libmcount/plthook-single.op
LIBMCOUNT_SINGLE_OBJS += $(patsubst $(srcdir)/%.c,$(objdir)/%.op,$(LIBMCOUNT_SINGLE_SRCS))

LIBMCOUNT_FAST_SINGLE_SRCS := $(srcdir)/utils/symbol.c $(srcdir)/utils/debug.c
LIBMCOUNT_FAST_SINGLE_SRCS += $(srcdir)/utils/demangle.c $(srcdir)/utils/utils.c
LIBMCOUNT_FAST_SINGLE_SRCS += $(srcdir)/utils/rbtree.c
LIBMCOUNT_FAST_SINGLE_SRCS += $(wildcard $(srcdir)/arch/$(ARCH)/mcount-support.c)
LIBMCOUNT_FAST_SINGLE_OBJS := $(objdir)/libmcount/mcount-fast-single.op
LIBMCOUNT_FAST_SINGLE_OBJS += $(objdir)/libmcount/record-fast-single.op
LIBMCOUNT_FAST_SINGLE_OBJS += $(objdir)/libmcount/plthook-fast-single.op
LIBMCOUNT_FAST_SINGLE_OBJS += $(patsubst $(srcdir)/%.c,$(objdir)/%.op,$(LIBMCOUNT_FAST_SINGLE_SRCS))

LIBMCOUNT_MCOUNT_OBJS := $(patsubst libmcount/lib%.so,$(objdir)/libmcount/%.op,$(LIBMCOUNT_TARGETS))
LIBMCOUNT_RECORD_OBJS := $(patsubst libmcount/libmcount%.so,$(objdir)/libmcount/record%.op,$(LIBMCOUNT_TARGETS))
LIBMCOUNT_PLTHOOK_OBJS := $(patsubst libmcount/libmcount%.so,$(objdir)/libmcount/plthook%.op,$(LIBMCOUNT_TARGETS))

LIBMCOUNT_COMMON_OBJS := $(filter-out $(objdir)/libmcount/mcount.op,$(LIBMCOUNT_OBJS))
LIBMCOUNT_COMMON_OBJS := $(filter-out $(objdir)/libmcount/record.op,$(LIBMCOUNT_COMMON_OBJS))
LIBMCOUNT_COMMON_OBJS := $(filter-out $(objdir)/libmcount/plthook.op,$(LIBMCOUNT_COMMON_OBJS))

COMMON_DEPS := $(objdir)/.config $(UFTRACE_HDRS)

CFLAGS_$(objdir)/mcount.op = -pthread
CFLAGS_$(objdir)/cmd-record.o = -DINSTALL_LIB_PATH='"$(libdir)"'
LDFLAGS_$(objdir)/uftrace = -L$(objdir)/libtraceevent -ltraceevent -ldl

CFLAGS_$(objdir)/libmcount/mcount-fast.op = -DDISABLE_MCOUNT_FILTER
CFLAGS_$(objdir)/libmcount/record-fast.op = -DDISABLE_MCOUNT_FILTER
CFLAGS_$(objdir)/libmcount/plthook-fast.op = -DDISABLE_MCOUNT_FILTER
CFLAGS_$(objdir)/libmcount/mcount-single.op = -DSINGLE_THREAD
CFLAGS_$(objdir)/libmcount/record-single.op = -DSINGLE_THREAD
CFLAGS_$(objdir)/libmcount/plthook-single.op = -DSINGLE_THREAD
CFLAGS_$(objdir)/libmcount/mcount-fast-single.op = -DDISABLE_MCOUNT_FILTER -DSINGLE_THREAD
CFLAGS_$(objdir)/libmcount/record-fast-single.op = -DDISABLE_MCOUNT_FILTER -DSINGLE_THREAD
CFLAGS_$(objdir)/libmcount/plthook-fast-single.op = -DDISABLE_MCOUNT_FILTER -DSINGLE_THREAD

CFLAGS_$(objdir)/utils/demangle.o  = -Wno-unused-value
CFLAGS_$(objdir)/utils/demangle.op = -Wno-unused-value

MAKEFLAGS = --no-print-directory


all: $(objdir)/.config $(TARGETS)

$(objdir)/.config: $(srcdir)/configure
	$(QUIET_GEN)$(srcdir)/configure -o $@ $(MAKEOVERRIDES)

config: $(srcdir)/configure
	$(QUIET_GEN)$(srcdir)/configure -o $(objdir)/.config $(MAKEOVERRIDES)

$(LIBMCOUNT_COMMON_OBJS): $(objdir)/%.op: $(srcdir)/%.c $(COMMON_DEPS)
	$(QUIET_CC_FPIC)$(CC) $(LIB_CFLAGS) -c -o $@ $<

$(LIBMCOUNT_MCOUNT_OBJS): $(objdir)/%.op: $(srcdir)/libmcount/mcount.c $(COMMON_DEPS)
	$(QUIET_CC_FPIC)$(CC) $(LIB_CFLAGS) -c -o $@ $<

$(LIBMCOUNT_RECORD_OBJS): $(objdir)/%.op: $(srcdir)/libmcount/record.c $(COMMON_DEPS)
	$(QUIET_CC_FPIC)$(CC) $(LIB_CFLAGS) -c -o $@ $<

$(LIBMCOUNT_PLTHOOK_OBJS): $(objdir)/%.op: $(srcdir)/libmcount/plthook.c $(COMMON_DEPS)
	$(QUIET_CC_FPIC)$(CC) $(LIB_CFLAGS) -c -o $@ $<

$(objdir)/libmcount/mcount-nop.op: $(srcdir)/libmcount/mcount-nop.c $(COMMON_DEPS)
	$(QUIET_CC_FPIC)$(CC) $(LIB_CFLAGS) -c -o $@ $<

$(objdir)/arch/$(ARCH)/entry.op: $(wildcard $(srcdir)/arch/$(ARCH)/*.[cS]) $(COMMON_DEPS)
	@$(MAKE) -B -C $(srcdir)/arch/$(ARCH) $@

$(objdir)/libmcount/libmcount.so: $(LIBMCOUNT_OBJS) $(objdir)/arch/$(ARCH)/entry.op
	$(QUIET_LINK)$(CC) -shared -o $@ $^ $(LIB_LDFLAGS)

$(objdir)/libmcount/libmcount-nop.so: $(LIBMCOUNT_NOP_OBJS)
	$(QUIET_LINK)$(CC) -shared -o $@ $^ $(LIB_LDFLAGS)

$(objdir)/libmcount/libmcount-fast.so: $(LIBMCOUNT_FAST_OBJS) $(objdir)/arch/$(ARCH)/entry.op
	$(QUIET_LINK)$(CC) -shared -o $@ $^ $(LIB_LDFLAGS)

$(objdir)/libmcount/libmcount-single.so: $(LIBMCOUNT_SINGLE_OBJS) $(objdir)/arch/$(ARCH)/entry.op
	$(QUIET_LINK)$(CC) -shared -o $@ $^ $(LIB_LDFLAGS)

$(objdir)/libmcount/libmcount-fast-single.so: $(LIBMCOUNT_FAST_SINGLE_OBJS) $(objdir)/arch/$(ARCH)/entry.op
	$(QUIET_LINK)$(CC) -shared -o $@ $^ $(LIB_LDFLAGS)

$(objdir)/libtraceevent/libtraceevent.a: PHONY
	@$(MAKE) -C $(srcdir)/libtraceevent BUILD_SRC=$(srcdir)/libtraceevent BUILD_OUTPUT=$(objdir)/libtraceevent CONFIG_FLAGS="$(TRACEEVENT_CFLAGS)"

$(objdir)/uftrace.o: $(srcdir)/uftrace.c $(objdir)/version.h $(COMMON_DEPS)
	$(QUIET_CC)$(CC) $(UFTRACE_CFLAGS) -c -o $@ $<

$(filter-out $(objdir)/uftrace.o,$(UFTRACE_OBJS)): $(objdir)/%.o: $(srcdir)/%.c $(COMMON_DEPS)
	$(QUIET_CC)$(CC) $(UFTRACE_CFLAGS) -c -o $@ $<

$(objdir)/version.h: PHONY
	@$(srcdir)/misc/version.sh $@ $(VERSION_GIT)

$(objdir)/uftrace: $(UFTRACE_OBJS) $(objdir)/libtraceevent/libtraceevent.a
	$(QUIET_LINK)$(CC) $(UFTRACE_CFLAGS) -o $@ $(UFTRACE_OBJS) $(UFTRACE_LDFLAGS)

install: all
	$(Q)$(INSTALL) -d -m 755 $(DESTDIR)$(bindir)
	$(Q)$(INSTALL) -d -m 755 $(DESTDIR)$(libdir)
	$(Q)$(INSTALL) -d -m 755 $(DESTDIR)$(etcdir)/bash_completion.d
	$(call QUIET_INSTALL, uftrace)
	$(Q)$(INSTALL) $(objdir)/uftrace         $(DESTDIR)$(bindir)/uftrace
	$(call QUIET_INSTALL, libmcount)
	$(Q)$(INSTALL) $(objdir)/libmcount/libmcount.so   $(DESTDIR)$(libdir)/libmcount.so
	$(Q)$(INSTALL) $(objdir)/libmcount/libmcount-nop.so $(DESTDIR)$(libdir)/libmcount-nop.so
	$(Q)$(INSTALL) $(objdir)/libmcount/libmcount-fast.so $(DESTDIR)$(libdir)/libmcount-fast.so
	$(Q)$(INSTALL) $(objdir)/libmcount/libmcount-single.so $(DESTDIR)$(libdir)/libmcount-single.so
	$(Q)$(INSTALL) $(objdir)/libmcount/libmcount-fast-single.so $(DESTDIR)$(libdir)/libmcount-fast-single.so
	$(call QUIET_INSTALL, bash-completion)
	$(Q)$(INSTALL) -m 644 $(srcdir)/misc/bash-completion.sh $(DESTDIR)$(etcdir)/bash_completion.d/uftrace
	@$(MAKE) -sC $(srcdir)/doc install DESTDIR=$(DESTDIR)$(mandir)
	@if [ `id -u` = 0 ]; then ldconfig $(DESTDIR)$(libdir) || echo "ldconfig failed"; fi

uninstall:
	$(call QUIET_UNINSTALL, uftrace)
	$(Q)$(RM) $(DESTDIR)$(bindir)/uftrace
	$(call QUIET_UNINSTALL, libmcount)
	$(Q)$(RM) $(DESTDIR)$(libdir)/libmcount{,-nop,-fast,-single,-fast-single}.so
	$(call QUIET_UNINSTALL, bash-completion)
	$(Q)$(RM) $(DESTDIR)$(etcdir)/bash_completion.d/uftrace
	@$(MAKE) -sC $(srcdir)/doc uninstall DESTDIR=$(DESTDIR)$(mandir)

test: all
	@$(MAKE) -C $(srcdir)/tests TESTARG="$(TESTARG)" test

dist:
	@git archive --prefix=uftrace-$(VERSION)/ $(VERSION_GIT) -o $(objdir)/uftrace-$(VERSION).tar
	@tar rf $(objdir)/uftrace-$(VERSION).tar --transform="s|^|uftrace-$(VERSION)/|" $(objdir)/version.h
	@gzip $(objdir)/uftrace-$(VERSION).tar

doc:
	@$(MAKE) -C $(srcdir)/doc

clean:
	$(call QUIET_CLEAN, uftrace)
	$(Q)$(RM) $(objdir)/*.o $(objdir)/*.op $(objdir)/*.so $(objdir)/*.a
	$(Q)$(RM) $(objdir)/utils/*.o $(objdir)/utils/*.op $(objdir)/libmcount/*.op
	$(Q)$(RM) $(objdir)/gmon.out $(TARGETS)
	$(Q)$(RM) $(objdir)/uftrace-*.tar.gz $(objdir)/version.h
	@$(MAKE) -sC $(srcdir)/arch/$(ARCH) clean
	@$(MAKE) -sC $(srcdir)/tests ARCH=$(ARCH) clean

=== config/Makefile ===
CHECK_LIST  = clock_without_librt cc_has_mfentry cxa_demangle

ifndef BUILD_FEATURE_CHECKS

  ifeq ($(wildcard config/check-tstamp),)
    $(shell make -si -C config check-build BUILD_FEATURE_CHECKS=1)
  endif

  ifeq ($(wildcard config/clock_without_librt),)
    LDFLAGS_libmcount.so += -lrt
  endif

  ifneq ($(wildcard config/cc_has_mfentry),)
    export HAVE_CC_MFENTRY = 1
  endif

  ifneq ($(wildcard config/cxa_demangle),)
    COMMON_CFLAGS += -DHAVE_CXA_DEMANGLE
    COMMON_LDFLAGS += -lstdc++
  endif

else # BUILD_FEATURE_CHECKS

#
# This is needed for build config tests
#

CFLAGS = $(CFLAGS_$@)
LDFLAGS = $(LDFLAGS_$@)

CFLAGS_cc_has_mfentry = -mfentry
LDFLAGS_cxa_demangle = -lstdc++

check-build: check-tstamp $(CHECK_LIST)

$(CHECK_LIST): %: check-%.c
	@$(CC) $(CFLAGS) -o $@ $< $(LDFLAGS) > /dev/null 2>&1

check-tstamp: PHONY
	@touch $@

.PHONY: PHONY;

endif # BUILD_FEATURE_CHECKS

check-clean:
	@$(RM) $(CHECK_LIST) check-tstamp *.o

=== doc/Makefile ===
all:

has_pandoc := $(shell pandoc -v > /dev/null 2>&1 && echo yes || echo no)

RM := rm -f
INSTALL = install

include ../config/Makefile.include

COMMANDS = record replay live report recv info dump graph
MANPAGES = uftrace.1 $(patsubst %,uftrace-%.1,$(COMMANDS))

ifeq ($(has_pandoc),yes)

all: $(MANPAGES)

%.1: %.md
	$(QUIET_GEN)pandoc -s $< -t man -o $@

# $(DESTDIR) already contains $(mandir) by ../Makefile
install: all
	$(call QUIET_INSTALL, man-pages)
	$(Q)$(INSTALL) -d -m 755 $(DESTDIR)/man1
	$(Q)for F in $(MANPAGES); do $(INSTALL) -m 644 $${F} $(DESTDIR)/man1; done

uninstall:
	$(call QUIET_UNINSTALL, man-pages)
	$(Q)for F in $(MANPAGES); do ${RM} $(DESTDIR)/man1/$${F}; done

clean:
	$(call QUIET_CLEAN, man-pages)
	$(Q)$(RM) *.1

else
  ifneq ($(MAKECMDGOALS),clean)
    $(warning To install man pages, please install 'pandoc'.)
  endif

install:

uninstall:

clean:

endif

.PHONY: all clean PHONY

=== libtraceevent/Makefile ===
# trace-cmd version
EP_VERSION = 1
EP_PATCHLEVEL = 1
EP_EXTRAVERSION = 0

# file format version
FILE_VERSION = 6

MAKEFLAGS += --no-print-directory


# Makefiles suck: This macro sets a default value of $(2) for the
# variable named by $(1), unless the variable has been set by
# environment or command line. This is necessary for CC and AR
# because make sets default values, so the simpler ?= approach
# won't work as expected.
define allow-override
  $(if $(or $(findstring environment,$(origin $(1))),\
            $(findstring command line,$(origin $(1)))),,\
    $(eval $(1) = $(2)))
endef

# Allow setting CC and AR, or setting CROSS_COMPILE as a prefix.
$(call allow-override,CC,$(CROSS_COMPILE)gcc)
$(call allow-override,AR,$(CROSS_COMPILE)ar)

EXT = -std=gnu99
INSTALL = install

# Use DESTDIR for installing into a different root directory.
# This is useful for building a package. The program will be
# installed in this directory as if it was the root directory.
# Then the build tool can move it later.
DESTDIR ?=
DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'

prefix ?= /usr/local
bindir_relative = bin
bindir = $(prefix)/$(bindir_relative)
man_dir = $(prefix)/share/man
man_dir_SQ = '$(subst ','\'',$(man_dir))'

export man_dir man_dir_SQ INSTALL
export DESTDIR DESTDIR_SQ

include $(if $(BUILD_SRC),$(BUILD_SRC)/)../config/Makefile.include

# copy a bit from Linux kbuild

ifeq ("$(origin V)", "command line")
  VERBOSE = $(V)
endif
ifndef VERBOSE
  VERBOSE = 0
endif

ifeq ("$(origin O)", "command line")
  BUILD_OUTPUT := $(O)
endif

ifeq ($(BUILD_SRC),)
ifneq ($(BUILD_OUTPUT),)

define build_output
  $(if $(VERBOSE:1=),@)+$(MAKE) -C $(BUILD_OUTPUT) \
  BUILD_SRC=$(CURDIR)/ -f $(CURDIR)/Makefile $1
endef

all: sub-make

$(MAKECMDGOALS): sub-make

sub-make: force
	$(call build_output, $(MAKECMDGOALS))


# Leave processing to above invocation of make
skip-makefile := 1

endif # BUILD_OUTPUT
endif # BUILD_SRC

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

srctree		:= $(if $(BUILD_SRC),$(BUILD_SRC),$(CURDIR))
objtree		:= $(if $(BUILD_OUTPUT),$(BUILD_OUTPUT),$(CURDIR))
src		:= $(srctree)
obj		:= $(objtree)

export prefix bindir src obj

# Shell quotes
bindir_SQ = $(subst ','\'',$(bindir))
bindir_relative_SQ = $(subst ','\'',$(bindir_relative))

LIB_FILE = $(obj)/libtraceevent.a # $(obj)/libtraceevent.so

CONFIG_INCLUDES = 
CONFIG_LIBS	=
CONFIG_FLAGS	=

VERSION		= $(EP_VERSION)
PATCHLEVEL	= $(EP_PATCHLEVEL)
EXTRAVERSION	= $(EP_EXTRAVERSION)

OBJ		= $@
N		=

export Q VERBOSE

EVENT_PARSE_VERSION = $(EP_VERSION).$(EP_PATCHLEVEL).$(EP_EXTRAVERSION)

INCLUDES = -I $(srctree)/include $(CONFIG_INCLUDES)

# Set compile option CFLAGS if not set elsewhere
CFLAGS ?= -g -Wall

# Append required CFLAGS
override CFLAGS += $(CONFIG_FLAGS) $(INCLUDES)
override CFLAGS += $(udis86-flags) -D_GNU_SOURCE

ifeq ($(VERBOSE),1)
  Q =
else
  Q = @
endif

do_compile_shared_library =			\
	($(print_shared_lib_compile)		\
	$(CC) --shared $^ -o $@)

do_build_static_lib =				\
	($(print_static_lib_build)		\
	$(RM) $@;  $(AR) rcs $@ $^)


do_compile = $(QUIET_CC)$(CC) -c $(CFLAGS) $(EXT) $< -o $@;

$(obj)/%.o: $(src)/%.c
	$(call do_compile)

PEVENT_LIB_OBJS  = $(obj)/event-parse.o
PEVENT_LIB_OBJS += $(obj)/event-plugin.o
PEVENT_LIB_OBJS += $(obj)/trace-seq.o
PEVENT_LIB_OBJS += $(obj)/parse-filter.o
PEVENT_LIB_OBJS += $(obj)/parse-utils.o
PEVENT_LIB_OBJS += $(obj)/kbuffer-parse.o

ALL_OBJS = $(PEVENT_LIB_OBJS) $(PLUGIN_OBJS)

CMD_TARGETS = $(LIB_FILE) $(PLUGINS)

TARGETS = $(CMD_TARGETS)


all: all_cmd

all_cmd: $(CMD_TARGETS)

$(obj)/libtraceevent.so: $(PEVENT_LIB_OBJS)
	$(QUIET_LINK)$(CC) --shared $^ -o $@

$(obj)/libtraceevent.a: $(PEVENT_LIB_OBJS)
	$(QUIET_LINK)$(RM) $@; $(AR) rcs $@ $^

$(PEVENT_LIB_OBJS): $(obj)/%.o: $(src)/%.c TRACEEVENT-CFLAGS
	$(QUIET_CC_FPIC)$(CC) -c $(CFLAGS) $(EXT) $< -o $@

define make_version.h
  (echo '/* This file is automatically generated. Do not modify. */';		\
   echo \#define VERSION_CODE $(shell						\
   expr $(VERSION) \* 256 + $(PATCHLEVEL));					\
   echo '#define EXTRAVERSION ' $(EXTRAVERSION);				\
   echo '#define VERSION_STRING "'$(VERSION).$(PATCHLEVEL).$(EXTRAVERSION)'"';	\
   echo '#define FILE_VERSION '$(FILE_VERSION);					\
  ) > $1
endef

define update_version.h
  ($(call make_version.h, $@.tmp);		\
    if [ -r $@ ] && cmp -s $@ $@.tmp; then	\
      rm -f $@.tmp;				\
    else					\
      echo '  UPDATE                 $@';	\
      mv -f $@.tmp $@;				\
    fi);
endef

ep_version.h: force
	$(Q)$(N)$(call update_version.h)

VERSION_FILES = ep_version.h

define update_dir
  (echo $1 > $@.tmp;				\
   if [ -r $@ ] && cmp -s $@ $@.tmp; then	\
     rm -f $@.tmp;				\
   else						\
     echo '  UPDATE                 $@';	\
     mv -f $@.tmp $@;				\
   fi);
endef

## make deps

all_objs := $(sort $(ALL_OBJS))
all_deps := $(all_objs:$(obj)/%.o=$(obj)/.%.d)

# let .d file also depends on the source and header files
define check_deps
  @set -e; $(RM) $@; \
  $(CC) -MM $(CFLAGS) $< > $@.$$$$; \
  sed 's,\($*\)\.o[ :]*,\1.o $@ : ,g' < $@.$$$$ > $@; \
  $(RM) $@.$$$$
endef

$(all_deps): $(obj)/.%.d: $(src)/%.c
	$(Q)$(call check_deps)

$(all_objs) : $(obj)/%.o : $(obj)/.%.d

dep_includes := $(wildcard $(all_deps))

ifneq ($(dep_includes),)
 include $(dep_includes)
endif

### Detect environment changes
TRACK_CFLAGS = $(subst ','\'',$(CFLAGS)):$(ARCH):$(CROSS_COMPILE)

TRACEEVENT-CFLAGS: force
	@FLAGS='$(TRACK_CFLAGS)'; \
	    if test x"$$FLAGS" != x"`cat TRACEEVENT-CFLAGS 2>/dev/null`" ; then \
		echo 1>&2 "  FLAGS:   * new build flags or cross compiler"; \
		echo "$$FLAGS" >TRACEEVENT-CFLAGS; \
            fi

tags:	force
	$(RM) tags
	find . -name '*.[ch]' | xargs ctags --extra=+f --c-kinds=+px \
	--regex-c++='/_PE\(([^,)]*).*/PEVENT_ERRNO__\1/'

TAGS:	force
	$(RM) TAGS
	find . -name '*.[ch]' | xargs etags \
	--regex='/_PE(\([^,)]*\).*/PEVENT_ERRNO__\1/'

define do_install
	if [ ! -d '$(DESTDIR_SQ)$2' ]; then		\
		$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$2';	\
	fi;						\
	$(INSTALL) $1 '$(DESTDIR_SQ)$2'
endef

install_lib: all_cmd
	$(call QUIET_INSTALL, $(LIB_FILE)) \
		$(call do_install,$(LIB_FILE),$(bindir_SQ))

install: install_lib

clean:
	$(call QUIET_CLEAN, libtraceevent) \
		$(RM) $(obj)/*.o $(obj)/*~ $(TARGETS) $(obj)/*.a $(obj)/*.so \
		$(VERSION_FILES) $(obj)/.*.d $(RM) TRACEEVENT-CFLAGS tags TAGS

endif # skip-makefile

PHONY += force
force:

# Declare the contents of the .PHONY variable as phony.  We keep that
# information in a variable so we can use it in if_changed and friends.
.PHONY: $(PHONY)

=== tests/Makefile ===
TEST_CFLAGS  := -D_GNU_SOURCE -DUNIT_TEST -I$(srcdir) -I$(objdir)
TEST_CFLAGS  += -include $(srcdir)/tests/unittest.h
TEST_LDFLAGS := -L$(objdir)/libtraceevent -ltraceevent -lelf -pthread -lrt -ldl

UNIT_TEST_SRC := $(wildcard $(srcdir)/*.c $(srcdir)/utils/*.c)
UNIT_TEST_SRC += $(wildcard $(srcdir)/arch/$(ARCH)/*.c)
UNIT_TEST_OBJ := $(patsubst %.c,%.ot,$(UNIT_TEST_SRC))

include $(srcdir)/config/Makefile.include

test: test_unit test_run

test_run:
	./runtest.py $(TESTARG)

test_unit: unittest
	./unittest $(filter -d,$(TESTARG))

unittest: unittest.c unittest.h $(UNIT_TEST_OBJ)
	$(QUIET_LINK)$(CC) -o $@ $(TEST_CFLAGS) $< $(UNIT_TEST_OBJ) $(TEST_LDFLAGS)

$(UNIT_TEST_OBJ): %.ot: %.c
	$(QUIET_CC)$(CC) -o $@ -c $(TEST_CFLAGS) $^

clean:
	$(call QUIET_CLEAN, test)
	@rm -f *.o *.so *.pyc t-* unittest $(UNIT_TEST_OBJ)

.PHONY: clean test test_run test_unit

=== arch/arm/Makefile ===
ASFLAGS = -fPIC
LINKFLAGS = -r

sdir = $(srcdir)/arch/arm
odir = $(objdir)/arch/arm

include $(srcdir)/config/Makefile.include

ARCH_ENTRY_SRC = $(wildcard $(sdir)/*.S)

all: $(odir)/entry.op

$(odir)/entry.op: $(patsubst $(sdir)/%.S,$(odir)/%.op,$(ARCH_ENTRY_SRC))
	$(QUIET_LINK)$(LD) $(LINKFLAGS) -o $@ $^

$(odir)/%.op: $(sdir)/%.S
	$(QUIET_ASM)$(CC) $(ASFLAGS) -c -o $@ $<

clean:
	$(RM) $(odir)/*.op $(odir)/*.o

=== arch/x86_64/Makefile ===
ASFLAGS = -fPIC
LINKFLAGS = -r

sdir = $(srcdir)/arch/x86_64
odir = $(objdir)/arch/x86_64

include $(srcdir)/config/Makefile.include

ARCH_ENTRY_SRC = $(wildcard $(sdir)/*.S)

all: $(odir)/entry.op

$(odir)/entry.op: $(patsubst $(sdir)/%.S,$(odir)/%.op,$(ARCH_ENTRY_SRC))
	$(QUIET_LINK)$(LD) $(LINKFLAGS) -o $@ $^

$(odir)/%.op: $(sdir)/%.S
	$(QUIET_ASM)$(CC) $(ASFLAGS) -c -o $@ $<

clean:
	$(RM) $(odir)/*.op $(odir)/*.o

=== debian/changelog ===
uftrace (0.6.0.20161014-1) unstable; urgency=low

  * Initial packaging of git snapshot at commit 06e6740256 (closes: #839877).

 -- paul cannon <pik@debian.org>  Fri, 14 Oct 2016 10:55:12 -0500

=== debian/control ===
Source: uftrace
Section: utils
Priority: optional
Maintainer: paul cannon <pik@debian.org>
Build-Depends: debhelper (>= 9), libelf-dev, pandoc, python
Standards-Version: 3.9.8
Homepage: https://github.com/namhyung/uftrace

Package: uftrace
Architecture: amd64 armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Traces and analyzes execution of programs written in C/C++
 The uftrace tool is intended for tracing and analyzing the execution of
 programs written in C or C++. It was heavily inspired by the ftrace framework
 of the Linux kernel (especially the function graph tracer) and supports
 userspace programs. It supports various kinds of commands and filters to help
 analysis of the program's execution and performance.
 .
 It traces each function in the executable and shows time durations. It can
 also trace external library calls - but only entry and exit are supported, and
 internal function calls within the library cannot be traced unless the library
 itself was built with profiling enabled.
 .
 It can show detailed execution flow at function level, and report which
 function has the highest overhead. It also shows various information
 related to the execution environment.
 .
 You can setup filters to exclude or include specific functions when tracing.
 In addition, function arguments and return values can be saved and shown
 later.
 .
 The uftrace tool supports multi-process and/or multi-threaded applications.
 It can also trace kernel functions as well, with root privileges and if the
 system enables the function graph tracer in the kernel
 (CONFIG_FUNCTION_GRAPH_TRACER=y).

=== debian/rules ===
#!/usr/bin/make -f
#
# don't use $(MAKE) for the sub-makes here; having MAKEFLAGS=w active for
# config/Makefile makes its subshell `make` invocation produce output, which
# causes Make to try and parse that output as Makefile contents, which breaks.

%:
	dh $@

MAKEVARS := \
	V=1 \
	DESTDIR=$(CURDIR)/debian/tmp/ \
	CFLAGS_uftrace=-fPIE \
	CFLAGS_traceevent=-fPIE \
	LDFLAGS_uftrace=-pie

override_dh_auto_configure:
	LDFLAGS=-Wl,-z,now,-z,relro ./configure --prefix=/usr --libdir=/usr/lib/uftrace

override_dh_auto_build:
	MAKEFLAGS= make $(MAKEVARS)

override_dh_auto_install:
	MAKEFLAGS= make install $(MAKEVARS)

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	@# strip out ansi codes that are apparently not opt-outable in tests/unittest.c
	MAKEFLAGS= make test $(MAKEVARS) | sed -e "$$(printf 's/\033\\[[0-9;]*m//g')"
endif

override_dh_auto_clean:
	MAKEFLAGS= make clean
	$(RM) .config

=== debian/watch ===
# project does not yet have an established release plan; maintainer is expected
# either to coordinate with upstream or to test the current master branch head
# somewhat thoroughly before using a new upstream version.

## uftrace 0.6.2

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION := 0.6
+VERSION := 0.6.2
 
 # Makefiles suck: This macro sets a default value of $(2) for the
 # variable named by $(1), unless the variable has been set by
@@ -82,8 +82,11 @@
 
 all:
 
-include $(srcdir)/config/Makefile
-include $(srcdir)/config/Makefile.include
+ifneq ($(wildcard $(srcdir)/check-deps/check-tstamp),)
+  include $(srcdir)/check-deps/Makefile.check
+endif
+
+include $(srcdir)/Makefile.include
 
 
 LIBMCOUNT_TARGETS := libmcount/libmcount.so libmcount/libmcount-fast.so
@@ -98,7 +101,7 @@
 UFTRACE_SRCS += $(wildcard $(srcdir)/arch/$(ARCH)/regs.c)
 UFTRACE_OBJS := $(patsubst $(srcdir)/%.c,$(objdir)/%.o,$(UFTRACE_SRCS))
 
-UFTRACE_HDRS := $(wildcard $(srcdir)/*.h $(srcdir)/utils/*.h)
+UFTRACE_HDRS := $(filter-out $(srcdir)/version.h,$(wildcard $(srcdir)/*.h $(srcdir)/utils/*.h))
 UFTRACE_HDRS += $(srcdir)/libmcount/mcount.h
 
 LIBMCOUNT_SRCS := $(filter-out %-nop.c,$(wildcard $(srcdir)/libmcount/*.c))
@@ -174,6 +177,10 @@
 
 $(objdir)/.config: $(srcdir)/configure
 	$(QUIET_GEN)$(srcdir)/configure -o $@ $(MAKEOVERRIDES)
+	@$(MAKE) -C $(objdir)
+# The above recursive make will handle all build procedure with
+# updated dependency.  So just abort the current build.
+	$(error)
 
 config: $(srcdir)/configure
 	$(QUIET_GEN)$(srcdir)/configure -o $(objdir)/.config $(MAKEOVERRIDES)
@@ -211,7 +218,7 @@
 $(objdir)/libmcount/libmcount-fast-single.so: $(LIBMCOUNT_FAST_SINGLE_OBJS) $(objdir)/arch/$(ARCH)/entry.op
 	$(QUIET_LINK)$(CC) -shared -o $@ $^ $(LIB_LDFLAGS)
 
-$(objdir)/libtraceevent/libtraceevent.a: PHONY
+$(objdir)/libtraceevent/libtraceevent.a: $(wildcard $(srcdir)/libtraceevent/*.[ch]) $(objdir)/.config
 	@$(MAKE) -C $(srcdir)/libtraceevent BUILD_SRC=$(srcdir)/libtraceevent BUILD_OUTPUT=$(objdir)/libtraceevent CONFIG_FLAGS="$(TRACEEVENT_CFLAGS)"
 
 $(objdir)/uftrace.o: $(srcdir)/uftrace.c $(objdir)/version.h $(COMMON_DEPS)
@@ -265,9 +272,3 @@
 
 clean:
 	$(call QUIET_CLEAN, uftrace)
-	$(Q)$(RM) $(objdir)/*.o $(objdir)/*.op $(objdir)/*.so $(objdir)/*.a
-	$(Q)$(RM) $(objdir)/utils/*.o $(objdir)/utils/*.op $(objdir)/libmcount/*.op
-	$(Q)$(RM) $(objdir)/gmon.out $(TARGETS)
-	$(Q)$(RM) $(objdir)/uftrace-*.tar.gz $(objdir)/version.h
-	@$(MAKE) -sC $(srcdir)/arch/$(ARCH) clean
-	@$(MAKE) -sC $(srcdir)/tests ARCH=$(ARCH) clean

=== check-deps/Makefile ===
CHECK_LIST := clock_without_librt
CHECK_LIST += cc_has_mfentry
CHECK_LIST += cxa_demangle
CHECK_LIST += have_libelf

#
# This is needed for checking build dependency
#

CHECK_CFLAGS  = $(CFLAGS)  $(CFLAGS_$@)
CHECK_LDFLAGS = $(LDFLAGS) $(LDFLAGS_$@)

CFLAGS_cc_has_mfentry = -mfentry
LDFLAGS_cxa_demangle = -lstdc++
LDFLAGS_have_libelf = -lelf

check-build: check-tstamp $(CHECK_LIST)

$(CHECK_LIST): %: __%.c
	@$(CC) $(CHECK_CFLAGS) -o $@ $< $(CHECK_LDFLAGS) > /dev/null 2>&1

check-tstamp: PHONY
	@touch $@
	@if [ `id -u` -eq 0 ]; then chmod 666 $@; fi

check-clean:
	@$(RM) $(CHECK_LIST) check-tstamp *.o

.PHONY: PHONY;

=== doc/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 RM := rm -f
 INSTALL = install
 
-include ../config/Makefile.include
+include ../Makefile.include
 
 COMMANDS = record replay live report recv info dump graph
 MANPAGES = uftrace.1 $(patsubst %,uftrace-%.1,$(COMMANDS))

=== tests/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-TEST_CFLAGS  := -D_GNU_SOURCE -DUNIT_TEST -I$(srcdir) -I$(objdir)
+TEST_CFLAGS  := -D_GNU_SOURCE -DUNIT_TEST -I$(srcdir) -I$(objdir) -g
 TEST_CFLAGS  += -include $(srcdir)/tests/unittest.h
 TEST_LDFLAGS := -L$(objdir)/libtraceevent -ltraceevent -lelf -pthread -lrt -ldl
 
@@ -6,7 +6,7 @@
 UNIT_TEST_SRC += $(wildcard $(srcdir)/arch/$(ARCH)/*.c)
 UNIT_TEST_OBJ := $(patsubst %.c,%.ot,$(UNIT_TEST_SRC))
 
-include $(srcdir)/config/Makefile.include
+include $(srcdir)/Makefile.include
 
 test: test_unit test_run

=== arch/arm/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 sdir = $(srcdir)/arch/arm
 odir = $(objdir)/arch/arm
 
-include $(srcdir)/config/Makefile.include
+include $(srcdir)/Makefile.include
 
 ARCH_ENTRY_SRC = $(wildcard $(sdir)/*.S)

=== arch/x86_64/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 sdir = $(srcdir)/arch/x86_64
 odir = $(objdir)/arch/x86_64
 
-include $(srcdir)/config/Makefile.include
+include $(srcdir)/Makefile.include
 
 ARCH_ENTRY_SRC = $(wildcard $(sdir)/*.S)

=== debian/changelog ===
uftrace (0.6.2-2) unstable; urgency=low

  * Don't claim to build on armel; the vstr instructions used in the
    ARM port for this software are not available under armel
    (closes: #858554). Thanks to Adrian Bunk.

 -- paul cannon <pik@debian.org>  Thu, 23 Mar 2017 10:18:14 -0500

uftrace (0.6.2-1) unstable; urgency=low

  * New upstream release
  * Release strategy has been established; define debian/watch
  * Use pristine-tar

 -- paul cannon <pik@debian.org>  Thu, 16 Mar 2017 12:41:12 -0500

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Homepage: https://github.com/namhyung/uftrace
 
 Package: uftrace
-Architecture: amd64 armel armhf
+Architecture: amd64 armhf
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Traces and analyzes execution of programs written in C/C++
  The uftrace tool is intended for tracing and analyzing the execution of

=== debian/rules ===
--- 
+++ 
@@ -25,8 +25,7 @@
 
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_test:
-	@# strip out ansi codes that are apparently not opt-outable in tests/unittest.c
-	MAKEFLAGS= make test $(MAKEVARS) | sed -e "$$(printf 's/\033\\[[0-9;]*m//g')"
+	MAKEFLAGS= make test $(MAKEVARS) CFLAGS_unittest=-DUFTRACE_TEST_SUPPRESS_COLORS
 endif
 
 override_dh_auto_clean:
